// Adapters.h : CAdapters ̐錾

#ifndef __ADAPTERS_H_
#define __ADAPTERS_H_

#include "resource.h"       // C V{

/////////////////////////////////////////////////////////////////////////////
// CAdapters
class ATL_NO_VTABLE CAdapters : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CAdapters, &CLSID_AdapterCollection>,
	public IDispatchImpl<IAdapterCollection, &IID_IAdapterCollection, &LIBID_MACCAPLib>
{
public:
	CAdapters()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ADAPTERS)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CAdapters)
	COM_INTERFACE_ENTRY(IAdapterCollection)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

	HRESULT FinalConstruct();

	void FinalRelease()
	{
		for (VarsIter it = m_listAdapters.begin(); it != m_listAdapters.end(); it++)
			VariantClear(&(*it));
		m_listAdapters.clear();
	}

	inline ListVars& GetAdapters() { return m_listAdapters; }
// IAdapterCollection
public:
	HRESULT STDMETHODCALLTYPE get__NewEnum( 
            /* [retval][out] */ IUnknown __RPC_FAR *__RPC_FAR *ppUnk);

	HRESULT STDMETHODCALLTYPE get_Length( 
            /* [retval][out] */ long __RPC_FAR *pResult);
private:
	ListVars m_listAdapters;
};

#endif //__ADAPTERS_H_
