	
// Venders.h : CVenders ̐錾

#ifndef __VENDERS_H_
#define __VENDERS_H_

#include "resource.h"       // C V{

/////////////////////////////////////////////////////////////////////////////
// CVendors
class ATL_NO_VTABLE CVendors : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CVendors, &CLSID_VendorCollection>,
	public IDispatchImpl<IVendorCollection, &IID_IVendorCollection, &LIBID_MACCAPLib>
{
public:
	CVendors()
	{
		m_pUnkMarshaler = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_VENDERS)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CVendors)
	COM_INTERFACE_ENTRY(IVendorCollection)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

// IVendorCollection
public:
	HRESULT STDMETHODCALLTYPE get__NewEnum( 
            /* [retval][out] */ IUnknown __RPC_FAR *__RPC_FAR *ppUnk);
        
	HRESULT STDMETHODCALLTYPE get_Length( 
            /* [retval][out] */ long __RPC_FAR *pResult);
        
	HRESULT STDMETHODCALLTYPE Find( 
            /* [in] */ long Proto,
            /* [retval][out] */ BSTR __RPC_FAR *pResult);
};

#endif //__VENDERS_H_
